/*

2clseq. Copyright Fahiem Bacchus 2000--2002

 A DPLL solver based on performing extensive reasoning with the binary
 clause subtheory. Pronounced "Two" "Clause" "Eq"

Version 2.0.

The software available at this site is copyright (c) 2000-2002 Fahiem
Bacchus. All right are reserved. Use of this software is permitted for
non-commercial research purposes, and it may be copied only for that
use. All copies must include this copyright message. This software and
any documentation and/or information supplied with it is distributed
on an as is basis. Fahiem Bacchus and the University of Toronto make
no warranties, express or implied, including but not limited to
implied warranties of merchantability and fitness for a particular
purpose, regarding the documentation, functions or performance of such
software, documentation and/or information.

@misc{Bacchus:2clseq,
	author  = { Fahiem Bacchus },
	year    = { 2002 },
	title   = { {2clseq} a {DPLL} solver employing extensive binary clause reasoning },
	note    = { Available from 
                    http://www.cs.toronto.edu/\~{}fbacchus/2clseq.html }
}

*/

#ifndef __stats_H
#define __stats_H

//Statistics
extern long this_num_solutions;
extern long this_num_DPL_leaves;
extern long this_num_DPL;
extern long timed_out;
extern long pureReductions;
extern long subsumes;
extern long eqsfound;

extern long DPL_branches_saved;

extern long bclsResolved;
extern long bclsAdded;
extern long clauseHitsFound;
extern long clauseHitsChecked;
extern long litHitsFound;
extern long litHitsChecked;
extern long nClausesChecked;
//extern long parentHitsChecked;
//extern long parentHitsFound;
extern long nClausesHits;

extern double start_cpu_time;
extern double end_cpu_time;
extern double time_out_val;

double GetInternalRunTime(void);

extern long *ties;
extern long *choices;
extern int deepestlevel;
#endif /* __stats_H */
